diff a/src/hotspot/share/cds/aotClassLocation.hpp b/src/hotspot/share/cds/aotClassLocation.hpp
--- a/src/hotspot/share/cds/aotClassLocation.hpp
+++ b/src/hotspot/share/cds/aotClassLocation.hpp
@@ -32,10 +32,11 @@
 #include "utilities/globalDefinitions.hpp"
 #include "utilities/macros.hpp"
 
 class AllClassLocationStreams;
 class ClassLocationStream;
+class ClassPathZipEntry;
 class LogStream;
 
 // An AOTClassLocation is a location where the application is configured to load Java classes
 // from. It can be:
 // - the location of $JAVA_HOME/lib/modules
@@ -137,10 +138,12 @@
   // Note: both of the following are non-null if we are dumping a dynamic archive.
   static AOTClassLocationConfig* _dumptime_instance;
   static const AOTClassLocationConfig* _runtime_instance;
 
   Array<AOTClassLocation*>* _class_locations; // jrt -> -Xbootclasspath/a -> -classpath -> --module_path
+  static Array<ClassPathZipEntry*>* _dumptime_jar_files;
+
   int _boot_classpath_end;
   int _app_classpath_end;
   int _module_end;
   bool _has_non_jar_modules;
   bool _has_platform_classes;
@@ -261,9 +264,11 @@
 
   AOTClassLocationConfig* write_to_archive() const;
 
   // Functions used only during runtime
   bool validate(bool has_aot_linked_classes, bool* has_extra_module_paths) const;
+
+  void check_invalid_classpath_index(int classpath_index, InstanceKlass* ik);
 };
 
 
 #endif // SHARE_CDS_AOTCLASSLOCATION_HPP
